JavaScript Data GridCell validator

Validate data added or changed by the user, with predefined or custom rules. Validation helps you make sure that the data matches the expected format.

Overview

When you create a validator, a good idea is to assign it as an alias that will refer to this particular validator function. Handsontable defines 5 aliases by default:

  • autocomplete for Handsontable.validators.AutocompleteValidator
  • date for Handsontable.validators.DateValidator
  • dropdown for Handsontable.validators.DropdownValidator
  • numeric for Handsontable.validators.NumericValidator
  • time for Handsontable.validators.TimeValidator

It gives users a convenient way for defining which validator should be used when table validation was triggered. User doesn't need to know which validator function is responsible for checking the cell value, he does not even need to know that there is any function at all. What is more, you can change the validator function associated with an alias without a need to change code that defines a table.

Register custom cell validator

To register your own alias use Handsontable.validators.registerValidator() function. It takes two arguments:

  • validatorName - a string representing a validator function
  • validator - a validator function that will be represented by validatorName

If you'd like to register creditCardValidator under alias credit-card you have to call:

Handsontable.validators.registerValidator('credit-card', creditCardValidator);

Choose aliases wisely. If you register your validator under name that is already registered, the target function will be overwritten:

Handsontable.validators.registerValidator('date', creditCardValidator);

Now 'date' alias points to creditCardValidator function, not Handsontable.validators.DateValidator.

So, unless you intentionally want to overwrite an existing alias, try to choose a unique name. A good practice is prefixing your aliases with some custom name (for example your GitHub username) to minimize the possibility of name collisions. This is especially important if you want to publish your validator, because you never know aliases has been registered by the user who uses your validator.

Handsontable.validators.registerValidator('credit-card', creditCardValidator);

Someone might already registered such alias.

Handsontable.validators.registerValidator('my.credit-card', creditCardValidator);

That's better.

Using an alias

The final touch is to use the registered aliases, so that users can easily refer to it without the need to now the actual validator function is.

To sum up, a well prepared validator function should look like this:

(Handsontable => {
  function customValidator(query, callback) {
    // ...your custom logic of the validator

    callback(/* Pass `true` or `false` based on your logic */);
  }

  // Register an alias
  Handsontable.validators.registerValidator('my.custom', customValidator);

})(Handsontable);

From now on, you can use customValidator like so:

const container = document.querySelector('#container')
const hot = new Handsontable(container, {
  columns: [{
    validator: 'my.custom'
  }]
});

Use the validator method to easily validate synchronous or asynchronous changes to a cell. If you need more control, beforeValidate and afterValidate hooks are available. In the below example, email_validator_fn is an async validator that resolves after 1000 ms.

Use the allowInvalid option to define if the grid should accept input that does not validate. If you need to modify the input (e.g., censor bad words, uppercase first letter), use the plugin hook beforeChange.

By default, all invalid cells are marked by htInvalid CSS class. If you want to change class to another you can basically add the invalidCellClassName option to Handsontable settings. For example:

For the entire table

invalidCellClassName: 'myInvalidClass'

Here you will see the log

    Edit the above grid to see the changes argument from the callback.

    Mind that changes in table are applied after running all validators (both synchronous and and asynchronous) from every changed cell.

React Data GridCell validator

Validate data added or changed by the user, with predefined or custom rules. Validation helps you make sure that the data matches the expected format.

Overview

When you create a validator, a good idea is to assign it as an alias that will refer to this particular validator function. Handsontable defines 5 aliases by default:

  • autocomplete for Handsontable.validators.AutocompleteValidator
  • date for Handsontable.validators.DateValidator
  • dropdown for Handsontable.validators.DropdownValidator
  • numeric for Handsontable.validators.NumericValidator
  • time for Handsontable.validators.TimeValidator

It gives users a convenient way for defining which validator should be used when table validation was triggered. User doesn't need to know which validator function is responsible for checking the cell value, he does not even need to know that there is any function at all. What is more, you can change the validator function associated with an alias without a need to change code that defines a table.

Register custom cell validator

To register your own alias use Handsontable.validators.registerValidator() function. It takes two arguments:

  • validatorName - a string representing a validator function
  • validator - a validator function that will be represented by validatorName

If you'd like to register creditCardValidator under alias credit-card you have to call:

Handsontable.validators.registerValidator('credit-card', creditCardValidator);

Choose aliases wisely. If you register your validator under name that is already registered, the target function will be overwritten:

Handsontable.validators.registerValidator('date', creditCardValidator);

Now 'date' alias points to creditCardValidator function, not Handsontable.validators.DateValidator.

So, unless you intentionally want to overwrite an existing alias, try to choose a unique name. A good practice is prefixing your aliases with some custom name (for example your GitHub username) to minimize the possibility of name collisions. This is especially important if you want to publish your validator, because you never know aliases has been registered by the user who uses your validator.

Handsontable.validators.registerValidator('credit-card', creditCardValidator);

Someone might already registered such alias.

Handsontable.validators.registerValidator('my.credit-card', creditCardValidator);

That's better.

Using an alias

The final touch is to use the registered aliases, so that users can easily refer to it without the need to now the actual validator function is.

To sum up, a well prepared validator function should look like this:

(Handsontable => {
  function customValidator(query, callback) {
    // ...your custom logic of the validator

    callback(/* Pass `true` or `false` based on your logic */);
  }

  // Register an alias
  Handsontable.validators.registerValidator('my.custom', customValidator);

})(Handsontable);

From now on, you can use customValidator like so:

<HotTable
  columns={[{
    validator: 'my.custom'
  }]}
/>

Use the validator method to easily validate synchronous or asynchronous changes to a cell. If you need more control, beforeValidate and afterValidate hooks are available. In the below example, email_validator_fn is an async validator that resolves after 1000 ms.

Use the allowInvalid option to define if the grid should accept input that does not validate. If you need to modify the input (e.g., censor bad words, uppercase first letter), use the plugin hook beforeChange.

By default, all invalid cells are marked by htInvalid CSS class. If you want to change class to another you can basically add the invalidCellClassName option to Handsontable settings. For example:

For the entire table

invalidCellClassName="myInvalidClass"

For specific columns

columns={[
  { data: 'firstName', invalidCellClassName: 'myInvalidClass' },
  { data: 'lastName', invalidCellClassName: 'myInvalidSecondClass' },
  { data: 'address' }
]}

Callback console log:

import { useState } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const [output, setOutput] = useState('');
  const ipValidatorRegexp =
    /^(?:\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b|null)$/;

  const emailValidator = (value, callback) => {
    setTimeout(() => {
      if (/.+@.+/.test(value)) {
        callback(true);
      } else {
        callback(false);
      }
    }, 1000);
  };

  return (
    <>
      <div className="example-controls-container">
        <output className="console" id="output">
          {output}
        </output>
      </div>
      <HotTable
        themeName="ht-theme-main"
        data={[
          {
            id: 1,
            name: { first: 'Joe', last: 'Fabiano' },
            ip: '0.0.0.1',
            email: 'Joe.Fabiano@ex.com',
          },
          {
            id: 2,
            name: { first: 'Fred', last: 'Wecler' },
            ip: '0.0.0.1',
            email: 'Fred.Wecler@ex.com',
          },
          {
            id: 3,
            name: { first: 'Steve', last: 'Wilson' },
            ip: '0.0.0.1',
            email: 'Steve.Wilson@ex.com',
          },
          {
            id: 4,
            name: { first: 'Maria', last: 'Fernandez' },
            ip: '0.0.0.1',
            email: 'M.Fernandez@ex.com',
          },
          {
            id: 5,
            name: { first: 'Pierre', last: 'Barbault' },
            ip: '0.0.0.1',
            email: 'Pierre.Barbault@ex.com',
          },
          {
            id: 6,
            name: { first: 'Nancy', last: 'Moore' },
            ip: '0.0.0.1',
            email: 'Nancy.Moore@ex.com',
          },
          {
            id: 7,
            name: { first: 'Barbara', last: 'MacDonald' },
            ip: '0.0.0.1',
            email: 'B.MacDonald@ex.com',
          },
          {
            id: 8,
            name: { first: 'Wilma', last: 'Williams' },
            ip: '0.0.0.1',
            email: 'Wilma.Williams@ex.com',
          },
          {
            id: 9,
            name: { first: 'Sasha', last: 'Silver' },
            ip: '0.0.0.1',
            email: 'Sasha.Silver@ex.com',
          },
          {
            id: 10,
            name: { first: 'Don', last: 'Pérignon' },
            ip: '0.0.0.1',
            email: 'Don.Pérignon@ex.com',
          },
          {
            id: 11,
            name: { first: 'Aaron', last: 'Kinley' },
            ip: '0.0.0.1',
            email: 'Aaron.Kinley@ex.com',
          },
        ]}
        beforeChange={function (changes, _source) {
          const cellChanges = changes;

          for (let i = changes.length - 1; i >= 0; i--) {
            // gently don't accept the word "foo" (remove the change at index i)
            if (cellChanges[i][3] === 'foo') {
              changes.splice(i, 1);
            }
            // if any of pasted cells contains the word "nuke", reject the whole paste
            else if (cellChanges[i][3] === 'nuke') {
              return false;
            }
            // capitalise first letter in column 1 and 2
            else if (cellChanges[i][1] === 'name.first' || cellChanges[i][1] === 'name.last') {
              if (cellChanges[i][3] !== null) {
                cellChanges[i][3] = cellChanges[i][3].charAt(0).toUpperCase() + cellChanges[i][3].slice(1);
              }
            }
          }
        }}
        afterChange={function (changes, source) {
          if (source !== 'loadData' && source !== 'updateData') {
            setOutput(JSON.stringify(changes));
          }
        }}
        colHeaders={['ID', 'First name', 'Last name', 'IP', 'E-mail']}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
        columns={[
          { data: 'id', type: 'numeric' },
          { data: 'name.first' },
          { data: 'name.last' },
          { data: 'ip', validator: ipValidatorRegexp, allowInvalid: true },
          { data: 'email', validator: emailValidator, allowInvalid: false },
        ]}
      />
    </>
  );
};

export default ExampleComponent;

Edit the above grid to see the changes argument from the callback.

Mind that changes in table are applied after running all validators (both synchronous and and asynchronous) from every changed cell.

Skip to content

Cell validators run when a user finishes editing a cell. Use them to enforce data rules such as required fields, numeric ranges, or pattern matching.

Overview

When you create a validator, assign it an alias so you can reference it by name in column configuration. Handsontable defines 5 aliases by default:

  • autocomplete for Handsontable.validators.AutocompleteValidator
  • date for Handsontable.validators.DateValidator
  • dropdown for Handsontable.validators.DropdownValidator
  • numeric for Handsontable.validators.NumericValidator
  • time for Handsontable.validators.TimeValidator

Aliases give you a convenient way to specify which validator runs when table validation triggers. You don’t need to reference the validator function directly, and you can swap the function behind an alias without changing your column configuration.

Register custom cell validator

To register your own alias use Handsontable.validators.registerValidator() function. It takes two arguments:

  • validatorName - a string representing a validator function
  • validator - a validator function that will be represented by validatorName

If you’d like to register creditCardValidator under alias credit-card you have to call:

Handsontable.validators.registerValidator('credit-card', creditCardValidator);

Choose aliases wisely. If you register your validator under name that is already registered, the target function will be overwritten:

Handsontable.validators.registerValidator('date', creditCardValidator);

Now ‘date’ alias points to creditCardValidator function, not Handsontable.validators.DateValidator.

So, unless you intentionally want to overwrite an existing alias, try to choose a unique name. A good practice is prefixing your aliases with some custom name (for example your GitHub username) to minimize the possibility of name collisions. This is especially important if you want to publish your validator, because you never know aliases has been registered by the user who uses your validator.

Handsontable.validators.registerValidator('credit-card', creditCardValidator);

Someone might already registered such alias.

Handsontable.validators.registerValidator('my.credit-card', creditCardValidator);

That’s better.

Using an alias

The final touch is to use the registered aliases, so that you can easily refer to them without knowing the actual validator function.

To sum up, a well prepared validator function should look like this:

(Handsontable => {
function customValidator(query, callback) {
// ...your custom logic of the validator
callback(/* Pass `true` or `false` based on your logic */);
}
// Register an alias
Handsontable.validators.registerValidator('my.custom', customValidator);
})(Handsontable);

From now on, you can use customValidator like so:

<HotTable :settings="{ columns: [{ validator: 'my.custom' }] }" />

Use the validator method to easily validate synchronous or asynchronous changes to a cell. If you need more control, beforeValidate and afterValidate hooks are available. In the below example, email_validator_fn is an async validator that resolves after 1000 ms.

Use the allowInvalid option to define if the grid should accept input that does not validate. If you need to modify the input (e.g., censor bad words, uppercase first letter), use the plugin hook beforeChange.

By default, all invalid cells are marked by htInvalid CSS class. If you want to change class to another you can basically add the invalidCellClassName option to Handsontable settings. For example:

For the entire table

<HotTable :settings="{ invalidCellClassName: 'myInvalidClass' }" />

For specific columns

<HotTable :settings="{
columns: [
{ data: 'firstName', invalidCellClassName: 'myInvalidClass' },
{ data: 'lastName', invalidCellClassName: 'myInvalidSecondClass' },
{ data: 'address' }
]
}" />

Callback console log:

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
interface RowData {
id: number;
name: { first: string; last: string };
ip: string;
email: string;
}
const ipValidatorRegexp =
/^(?:\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b|null)$/;
const emailValidator = (value: string, callback: (valid: boolean) => void) => {
setTimeout(() => {
if (/.+@.+/.test(value)) {
callback(true);
} else {
callback(false);
}
}, 1000);
};
const output = ref('Here you will see the log');
const data: RowData[] = [
{ id: 1, name: { first: 'Joe', last: 'Fabiano' }, ip: '0.0.0.1', email: 'Joe.Fabiano@ex.com' },
{ id: 2, name: { first: 'Fred', last: 'Wecler' }, ip: '0.0.0.1', email: 'Fred.Wecler@ex.com' },
{ id: 3, name: { first: 'Steve', last: 'Wilson' }, ip: '0.0.0.1', email: 'Steve.Wilson@ex.com' },
{ id: 4, name: { first: 'Maria', last: 'Fernandez' }, ip: '0.0.0.1', email: 'M.Fernandez@ex.com' },
{ id: 5, name: { first: 'Pierre', last: 'Barbault' }, ip: '0.0.0.1', email: 'Pierre.Barbault@ex.com' },
{ id: 6, name: { first: 'Nancy', last: 'Moore' }, ip: '0.0.0.1', email: 'Nancy.Moore@ex.com' },
{ id: 7, name: { first: 'Barbara', last: 'MacDonald' }, ip: '0.0.0.1', email: 'B.MacDonald@ex.com' },
{ id: 8, name: { first: 'Wilma', last: 'Williams' }, ip: '0.0.0.1', email: 'Wilma.Williams@ex.com' },
{ id: 9, name: { first: 'Sasha', last: 'Silver' }, ip: '0.0.0.1', email: 'Sasha.Silver@ex.com' },
{ id: 10, name: { first: 'Don', last: 'Pérignon' }, ip: '0.0.0.1', email: 'Don.Pérignon@ex.com' },
{ id: 11, name: { first: 'Aaron', last: 'Kinley' }, ip: '0.0.0.1', email: 'Aaron.Kinley@ex.com' },
];
const hotSettings = ref<GridSettings>({
data,
beforeChange(changes) {
for (let i = changes.length - 1; i >= 0; i--) {
const currChange = changes[i];
if (!currChange) {
continue;
}
// gently don't accept the word "foo" (remove the change at index i)
if (currChange[3] === 'foo') {
changes.splice(i, 1);
}
// if any of pasted cells contains the word "nuke", reject the whole paste
else if (currChange[3] === 'nuke') {
return false;
}
// capitalise first letter in column 1 and 2
else if (currChange[1] === 'name.first' || currChange[1] === 'name.last') {
const newValue = currChange[3];
if (newValue !== null && typeof newValue === 'string') {
currChange[3] = newValue.charAt(0).toUpperCase() + newValue.slice(1);
}
}
}
return true;
},
afterChange(changes, source) {
if (source !== 'loadData') {
output.value = JSON.stringify(changes);
}
},
colHeaders: ['ID', 'First name', 'Last name', 'IP', 'E-mail'],
height: 'auto',
licenseKey: 'non-commercial-and-evaluation',
columns: [
{ data: 'id', type: 'numeric' },
{ data: 'name.first' },
{ data: 'name.last' },
{ data: 'ip', validator: ipValidatorRegexp, allowInvalid: true },
{ data: 'email', validator: emailValidator },
],
autoWrapRow: true,
autoWrapCol: true,
});
</script>
<template>
<div id="example1">
<div class="example-controls-container">
<output class="console" id="output">{{ output }}</output>
</div>
<HotTable :settings="hotSettings" />
</div>
</template>

Edit the above grid to see the changes argument from the callback.

Mind that changes in table are applied after running all validators (both synchronous and and asynchronous) from every changed cell.

APIs

Configuration options

Core methods

Hooks

Result

You now have a cell validator that enforces data rules when a user finishes editing. Register it under an alias to reference it by name across your column configuration, and use allowInvalid: false to keep the editor open until the user enters a valid value.

Angular Data GridCell validator

Validate data added or changed by the user, with predefined or custom rules. Validation helps you make sure that the data matches the expected format.

Overview

When you create a validator, a good idea is to assign it as an alias that will refer to this particular validator function. Handsontable defines 5 aliases by default:

  • autocomplete for Handsontable.validators.AutocompleteValidator
  • date for Handsontable.validators.DateValidator
  • dropdown for Handsontable.validators.DropdownValidator
  • numeric for Handsontable.validators.NumericValidator
  • time for Handsontable.validators.TimeValidator

It gives users a convenient way for defining which validator should be used when table validation was triggered. User doesn't need to know which validator function is responsible for checking the cell value, he does not even need to know that there is any function at all. What is more, you can change the validator function associated with an alias without a need to change code that defines a table.

Register custom cell validator

To register your own alias use Handsontable.validators.registerValidator() function. It takes two arguments:

  • validatorName - a string representing a validator function
  • validator - a validator function that will be represented by validatorName

If you'd like to register creditCardValidator under alias credit-card you have to call:

Handsontable.validators.registerValidator('credit-card', creditCardValidator);

Choose aliases wisely. If you register your validator under name that is already registered, the target function will be overwritten:

Handsontable.validators.registerValidator('date', creditCardValidator);

Now 'date' alias points to creditCardValidator function, not Handsontable.validators.DateValidator.

So, unless you intentionally want to overwrite an existing alias, try to choose a unique name. A good practice is prefixing your aliases with some custom name (for example your GitHub username) to minimize the possibility of name collisions. This is especially important if you want to publish your validator, because you never know aliases has been registered by the user who uses your validator.

Handsontable.validators.registerValidator('credit-card', creditCardValidator);

Someone might already registered such alias.

Handsontable.validators.registerValidator('my.credit-card', creditCardValidator);

That's better.

Using an alias

The final touch is to use the registered aliases, so that users can easily refer to it without the need to now the actual validator function is.

To sum up, a well prepared validator function should look like this:

(Handsontable => {
  function customValidator(query, callback) {
    // ...your custom logic of the validator

    callback(/* Pass `true` or `false` based on your logic */);
  }

  // Register an alias
  Handsontable.validators.registerValidator('my.custom', customValidator);

})(Handsontable);

From now on, you can use customValidator like so:

<hot-table [settings]="{
    columns: [{
        validator: 'my.custom'
    }]
  }">
</hot-table>

Use the validator method to easily validate synchronous or asynchronous changes to a cell. If you need more control, beforeValidate and afterValidate hooks are available. In the below example, email_validator_fn is an async validator that resolves after 1000 ms.

Use the allowInvalid option to define if the grid should accept input that does not validate. If you need to modify the input (e.g., censor bad words, uppercase first letter), use the plugin hook beforeChange.

By default, all invalid cells are marked by htInvalid CSS class. If you want to change class to another you can basically add the invalidCellClassName option to Handsontable settings. For example:

For the entire table

invalidCellClassName: 'myInvalidClass'

For specific columns

columns: [
  { data: 'firstName', invalidCellClassName: 'myInvalidClass' },
  { data: 'lastName', invalidCellClassName: 'myInvalidSecondClass' },
  { data: 'address' }
]

Callback console log:

Here you will see the log
/* file: app.component.ts */
import { Component, OnInit } from '@angular/core';
import { GridSettings } from "@handsontable/angular-wrapper";

const ipValidatorRegexp =
  /^(?:\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b|null)$/;

const emailValidator = (value: string, callback: (arg0: boolean) => void) => {
  setTimeout(() => {
    if (/.+@.+/.test(value)) {
      callback(true);
    } else {
      callback(false);
    }
  }, 1000);
};

@Component({
  selector: 'app-example1',
  template: `
    <output class="console">{{output}}</output>

    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent implements OnInit {
  output = 'Here you will see the log';

  readonly hotData = [
    {
      id: 1,
      name: { first: 'Joe', last: 'Fabiano' },
      ip: '0.0.0.1',
      email: 'Joe.Fabiano@ex.com',
    },
    {
      id: 2,
      name: { first: 'Fred', last: 'Wecler' },
      ip: '0.0.0.1',
      email: 'Fred.Wecler@ex.com',
    },
    {
      id: 3,
      name: { first: 'Steve', last: 'Wilson' },
      ip: '0.0.0.1',
      email: 'Steve.Wilson@ex.com',
    },
    {
      id: 4,
      name: { first: 'Maria', last: 'Fernandez' },
      ip: '0.0.0.1',
      email: 'M.Fernandez@ex.com',
    },
    {
      id: 5,
      name: { first: 'Pierre', last: 'Barbault' },
      ip: '0.0.0.1',
      email: 'Pierre.Barbault@ex.com',
    },
    {
      id: 6,
      name: { first: 'Nancy', last: 'Moore' },
      ip: '0.0.0.1',
      email: 'Nancy.Moore@ex.com',
    },
    {
      id: 7,
      name: { first: 'Barbara', last: 'MacDonald' },
      ip: '0.0.0.1',
      email: 'B.MacDonald@ex.com',
    },
    {
      id: 8,
      name: { first: 'Wilma', last: 'Williams' },
      ip: '0.0.0.1',
      email: 'Wilma.Williams@ex.com',
    },
    {
      id: 9,
      name: { first: 'Sasha', last: 'Silver' },
      ip: '0.0.0.1',
      email: 'Sasha.Silver@ex.com',
    },
    {
      id: 10,
      name: { first: 'Don', last: 'Pérignon' },
      ip: '0.0.0.1',
      email: 'Don.Pérignon@ex.com',
    },
    {
      id: 11,
      name: { first: 'Aaron', last: 'Kinley' },
      ip: '0.0.0.1',
      email: 'Aaron.Kinley@ex.com',
    },
  ];

  hotSettings!: GridSettings;

  ngOnInit() {
    const componentInstance = this;

    this.hotSettings = {
      beforeChange(changes) {
        for (let i = changes.length - 1; i >= 0; i--) {
          const currChange = changes[i];

          if (!currChange) {
            return false;
          }

          // gently don't accept the word "foo" (remove the change at index i)
          if (currChange[3] === 'foo') {
            changes.splice(i, 1);
          }
          // if any of pasted cells contains the word "nuke", reject the whole paste
          else if (currChange[3] === 'nuke') {
            return false;
          }
          // capitalise first letter in column 1 and 2
          else if (
            currChange[1] === 'name.first' ||
            currChange[1] === 'name.last'
          ) {
            if (currChange[3] !== null) {
              changes[i]![3] =
                currChange[3].charAt(0).toUpperCase() + currChange[3].slice(1);
            }
          }
        }

        return true;
      },
      afterChange(changes, source) {
        if (source !== 'loadData') {
          componentInstance.output = JSON.stringify(changes);
        }
      },
      colHeaders: ['ID', 'First name', 'Last name', 'IP', 'E-mail'],
      height: 'auto',
      licenseKey: 'non-commercial-and-evaluation',
      columns: [
        { data: 'id', type: 'numeric' },
        { data: 'name.first' },
        { data: 'name.last' },
        { data: 'ip', validator: ipValidatorRegexp, allowInvalid: true },
        { data: 'email', validator: emailValidator, allowInvalid: false },
      ],
      autoWrapRow: true,
      autoWrapCol: true,
    };
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Edit the above grid to see the changes argument from the callback.

Mind that changes in table are applied after running all validators (both synchronous and and asynchronous) from every changed cell.